# relval

relval is a tool for interacting with Fedora release validation
events, as stored in the Fedora wiki. It can create the pages for
validation events, and generate statistics about existing events.

## Creating events

Call 'relval compose' to do this. You pass relval parameters that tell
it what release, milestone, and compose you want to create pages for,
and what your FAS username is. Optionally you can pass a 'test type'
(Base, Cloud etc) to create only a single page of that type, --force to
force page creation even if the page already exists, and --current to
update the Current convenience redirect pages to point to the created
pages.

relval will create the individual result pages and the result summary
page. It will add pages to the appropriate category, add the results
category page to its parent category, add the parent category page to
its parent category, and populate both category pages with text.

## Generating statistics

### User contribution statistics

You can call 'relval user-stats' to generate statistics on user
contributions for some set of result pages. You must pass --release to
specify the release on which to operate. You may pass --milestone to
specify a particular milestone (otherwise, all pages for the release
will be considered) and/or --filter (possibly multiple times) to filter
the pages used based on their names. Only Pages matching any of the
--filter parameters will be included if --filter is passed.

The command will print the resulting HTML direct to the console -
it's expected that you'll copy and paste it into a blog entry, or
something similar.

### Test coverage statistics

You can call 'relval testcase-stats' to generate statistics on test
case coverage for some set of result pages. You must pass --release to
specify the release on which to operate. You may pass --milestone to
specify a particular milestone (otherwise, all pages for the release
will be considered) and/or --filter (possibly multiple times) to filter
the pages used based on their names. Only Pages matching any of the
--filter parameters will be included if --filter is passed.

This command creates a temporary directory and places all the output
there. You can copy this directory to a web server, and index.html
within provides a simple top-level page with links to summary pages
for each 'test type', which in turn provides links to detailed pages
for each test case. The summary pages provide a quick overview of test
coverage for each test case across the specified set of compose events
as a small graphic, and tell you which compose the test case was most
recently run against. The detail pages provide more detailed
information, including the number and type of results for each test
case for each compose, and any referenced bug reports.

## Credits

The `user-stats` and `testcase-stats` sub-commands are re-
implementations of work originally done by [Kamil Paral][1] and
[Josef Skladanka][2], and incorporate sections of the original
implementations, which can be found in the [fedora-qa git repository]
[3].

[Mike Ruckman][4] (roshi) has been kind and patient in providing
review and advice throughout wikitcms' development. Of course, all
errors are my own!

[1]: http://kparal.wordpress.com/
[2]: http://jskladan.wordpress.com/
[3]: https://git.fedorahosted.org/cgit/fedora-qa.git/tree/stats
[4]: https://roshi.fedorapeople.org/
